#!/bin/sh
# for eforth,lib4th/test4th, (C) 2001 by h-peter recktenwald <phpr@snafu.de>

d=$(pwd)/i/version.inc

# ---------------------------------------------------------------------------

[ -z "${2}" ]&&s=${d}||s=${2}

REL="$(grep "ne\ REL\ " ${s}|cut -d\  -f3||echo 0)"
VER="$(grep "ne\ VER\ " ${s}|cut -d\  -f3||echo 0)"
EXT="$(grep "ne\ EXT\ " ${s}|cut -d\  -f3||echo 0)"
TAG="$(grep "ne\ TAG\ " ${s}|cut -d\  -f3||echo 0)"

case ${1} in
    r)		# r
    echo ${REL};;
    v)		# v
    echo ${VER};;
    x)		# x
    echo ${EXT};;
    t)		# t
    echo ${TAG};;
    r.v)	# r.v
    echo ${REL}.${VER};;
    rvx)	# rvx
    echo ${REL}${VER}${EXT};;
    rvxt)	# rvx
    echo ${REL}-${VER}-${EXT}+${TAG};;
    v+|x+|r+|t+|tt|vv|xx|rr)	# next REL/VER/EXT number
        case ${1} in
	    r+|v+|x+)	( make uninstall >/dev/null 2>&1||true );;
	esac
	case ${1} in
	    r+|rr|v+|vv|x+|xx)
	    TAG=0
	    cp ${s} ${s}.old;;
	esac
        case ${1} in
	    r+|rr)	g=REL;EXT=00;VER=00;;	# r+
	    v+|vv)	g=VER;EXT=00;;		# v+
	    x+|xx)	g=EXT;;			# x+
	    t+|tt)	g=TAG;;			# t+
	esac
	export ${g}="$((10#$((10#$(grep "ne\ ${g}" ${s}|cut -d\  -f3)))+1))"
	eval [ "$((10#${EXT}))" -lt "$((10))" ]&&EXT=0$((10#${EXT}))
	echo "%define REL ${REL}"  > ${s}
	echo "%define VER ${VER}" >> ${s}
	echo "%define EXT ${EXT}" >> ${s}
	echo "%define TAG ${TAG}" >> ${s}
	;;
    -)
    echo ${REL}.${VER}.${EXT};;
    *-*)
	echo "
increment lib4th version number by one:
	rr:	REL
	vv:	VER
	xx:	EXT
uninstall current lib4th version and increment version number:
	r+:	REL \\
	v+:	VER  )TAG := 0
	x+:	EXT /
	t+:	TAG
echo lib4th version number to stdout:
	r: echo	REL
	v:	VER
	x:	EXT
	r.v:	REL.VER
	r.v.x:	REL.VER.EXT
	rvx	RELVEREXT
	rvxt	REL-VER-EXT+TAG
	-	REL.VER.EXT
	-none-	REL.VER.EXT
optional 2nd arg
	filename where to read the version data from,
	default is \"${d}\"."
	;;
    *)		# r.v.x
    echo ${REL}.${VER}.${EXT};;
esac
